classification
Title: Gestalt() is deprecated on OSX 10.8, remove support?
Type: behavior Stage: resolved
Components: Macintosh Versions: Python 3.4
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: ronaldoussoren Nosy List: lemburg, ned.deily, python-dev, ronaldoussoren
Priority: normal Keywords: easy, needs review, patch

Created on 2013-07-07 09:11 by ronaldoussoren, last changed 2013-07-16 06:32 by python-dev. This issue is now closed.

Files
File name Uploaded Description Edit
issue-18393.txt ronaldoussoren, 2013-07-08 07:44 review
Messages (10)
msg192526 - (view) Author: Ronald Oussoren (ronaldoussoren) * (Python committer) Date: 2013-07-07 09:11
In OSX 10.8 the Gestalt() funtion in CoreServices is deprecated. This function is used in the _gestalt extension and exported to Python code.

The only in-tree user of this (private) extension is the platform module, it uses gestalt as one of the alternatives to get the OSX release; and a fallback at that.

A stackoverflow user has done some sleuthing and discovered that the gestalt function uses the same XML file to determine the OSX release as is used by the primary alternative used by the platform module (see <http://stackoverflow.com/questions/11072804/mac-os-x-10-8-replacement-for-gestalt-for-testing-os-version-at-runtime>). The gestalt alternative will therefore likely be useful at all (it is only used when the file it reads is not available in the first place).

The easiest solution to avoid this deprecated API is therefore to drop the  _gestalt extension and remove its use in platform.mac_ver()
msg192627 - (view) Author: Ronald Oussoren (ronaldoussoren) * (Python committer) Date: 2013-07-08 07:44
The attached patch removes the use of the Gestalt API.

The removed code is effectively dead, I yet have to find a machine were platform._mac_ver_xml does not work and the gestalt based code only gets used when the XML variant does not work.
msg192635 - (view) Author: Marc-Andre Lemburg (lemburg) * (Python committer) Date: 2013-07-08 11:52
On 07.07.2013 11:11, Ronald Oussoren wrote:
> The easiest solution to avoid this deprecated API is therefore to drop the  _gestalt extension and remove its use in platform.mac_ver()

I think it should only be removed in case we no longer support
Mac OS X platforms that still have it. Otherwise, please simply
follow our standard procedure for deprecating public functions.
msg192637 - (view) Author: Ronald Oussoren (ronaldoussoren) * (Python committer) Date: 2013-07-08 11:55
Do we follow the deprecation procedure for private functions as well?

The patch removes a private and undocumented extension, and removes a private function that uses that extension. There is no change in the public API.

Also, as I mentioned before the removed code is effectively dead because it will never be called on systems that aren't totally broken.
msg192641 - (view) Author: Marc-Andre Lemburg (lemburg) * (Python committer) Date: 2013-07-08 12:03
On 08.07.2013 13:55, Ronald Oussoren wrote:
> 
> Do we follow the deprecation procedure for private functions as well?
> 
> The patch removes a private and undocumented extension, and removes a private function that uses that extension. There is no change in the public API.
> 
> Also, as I mentioned before the removed code is effectively dead because it will never be called on systems that aren't totally broken.

Oh, I was under the impression that the API is public. I just did a
grep: the _gestalt module is not documented and neither is the
gestalt function, so I guess we can speed up the deprecation procedure
or even drop it right away in 3.4 :-)
msg192642 - (view) Author: Ronald Oussoren (ronaldoussoren) * (Python committer) Date: 2013-07-08 12:08
I had hoped to just drop it in 3.4.

To remove:

* extension _gestalt

* function platform._mac_ver_gestalt

* function platform._mac_ver_lookup (only used by ^^^)

* function platform._bcd2str (likewise)

To change:

* function platform.mac_ver: remove call to _mac_ver_gestalt
msg192645 - (view) Author: Marc-Andre Lemburg (lemburg) * (Python committer) Date: 2013-07-08 12:36
On 08.07.2013 14:08, Ronald Oussoren wrote:
> 
> Ronald Oussoren added the comment:
> 
> I had hoped to just drop it in 3.4.
> 
> To remove:
> 
> * extension _gestalt
> 
> * function platform._mac_ver_gestalt
> 
> * function platform._mac_ver_lookup (only used by ^^^)
> 
> * function platform._bcd2str (likewise)
> 
> To change:
> 
> * function platform.mac_ver: remove call to _mac_ver_gestalt

Fine with me.
msg193116 - (view) Author: Roundup Robot (python-dev) Date: 2013-07-15 16:32
New changeset ccbaf6762b54 by Ronald Oussoren in branch 'default':
Issue #18393: Remove use of deprecated API on OSX
http://hg.python.org/cpython/rev/ccbaf6762b54
msg193119 - (view) Author: Ronald Oussoren (ronaldoussoren) * (Python committer) Date: 2013-07-15 16:38
I won't backport to 3.3 or 2.7, it is highly unlikely that the API will actually be removed anytime soon.
msg193156 - (view) Author: Roundup Robot (python-dev) Date: 2013-07-16 06:32
New changeset 7272ef213b7c by Ronald Oussoren in branch 'default':
Also remove a (broken) leaker test for the code removed in issue #18393.
http://hg.python.org/cpython/rev/7272ef213b7c
History
Date User Action Args
2013-07-16 06:32:31python-devsetmessages: + msg193156
2013-07-15 16:38:00ronaldoussorensetstatus: open -> closed
resolution: fixed
messages: + msg193119

stage: patch review -> resolved
2013-07-15 16:32:23python-devsetnosy: + python-dev
messages: + msg193116
2013-07-08 12:36:32lemburgsetmessages: + msg192645
2013-07-08 12:08:33ronaldoussorensetmessages: + msg192642
2013-07-08 12:03:53lemburgsetmessages: + msg192641
2013-07-08 11:55:14ronaldoussorensetmessages: + msg192637
2013-07-08 11:52:10lemburgsetnosy: + lemburg
messages: + msg192635
2013-07-08 07:44:42ronaldoussorensetkeywords: + patch, needs review
files: + issue-18393.txt
messages: + msg192627

stage: test needed -> patch review
2013-07-07 09:11:17ronaldoussorencreate